<?php
namespace Civi\Api4\Action\ContactCategory;

use Civi\Api4\Generic\Result;
use Civi\Api4\ContactCategory;
use CRM_Contactcats_ExtensionUtil as E;

/**
 * Create ContactCategory action
 *
 * This entity's ID is a unique primary key that references
 * contact_id. Here we overwrite the validateValues which normally
 *
 */
class Create extends \Civi\Api4\Generic\DAOCreateAction {

  /**
   * @inheritDoc
   */
  public function _run(Result $result) {
    // Wrap Save API
    $saveResults = ContactCategory::save($this->getCheckPermissions())
      ->addRecord($this->values)
      ->execute()->getArrayCopy();
    $result->exchangeArray($saveResults);
  }

}
