<?php
namespace Civi\Api4;

use Civi\Api4\Action\ContactCategory\GetFlows;
use Civi\Api4\Action\ContactCategory\Sync;
use Civi\Api4\Action\ContactCategory\Create;
use Civi\Api4\Action\ContactCategory\Save;

/**
 * ContactCategory entity.
 *
 * Provided by the Contact Categories extension.
 *
 * @package Civi\Api4
 */
class ContactCategory extends Generic\DAOEntity {

  /**
   * @param bool $checkPermissions
   * @return \Civi\Api4\Action\ContactCategory\Create
   */
  public static function create($checkPermissions = TRUE) {
    return (new Create(static::getEntityName(), __FUNCTION__))
      ->setCheckPermissions($checkPermissions);
  }

  /**
   * @param bool $checkPermissions
   * @return \Civi\Api4\Action\ContactCategory\Save
   */
  public static function save($checkPermissions = TRUE) {
    return (new Save(static::getEntityName(), __FUNCTION__))
      ->setCheckPermissions($checkPermissions);
  }

  /**
   *
   */
  public static function sync(): Sync {
    return new Sync('ContactCategory', 'sync');
  }

  /**
   *
   */
  public static function getFlows(): GetFlows {
    return new GetFlows('ContactCategory', 'getFlows');
  }

}
