<?php

require_once 'contactcats.civix.php';

use CRM_Contactcats_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/
 */
function contactcats_civicrm_config(&$config): void {
  _contactcats_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function contactcats_civicrm_install(): void {
  _contactcats_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function contactcats_civicrm_enable(): void {
  _contactcats_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu
 */
function contactcats_civicrm_navigationMenu(&$menu) {
  _contactcats_civix_insert_navigation_menu($menu, 'Contacts', [
    'label' => E::ts('Categories'),
    'name' => 'contact_categories',
    'url' => 'civicrm/admin/contactcategory',
    'permission' => 'edit all contacts',
    'operator' => 'OR',
    'separator' => 0,
  ]);
  _contactcats_civix_insert_navigation_menu($menu, 'Reports', [
    'label' => E::ts('Contact Category Flows'),
    'name' => 'contact_category_flows',
    'url' => 'civicrm/reports/contact-category-flows',
    'permission' => 'access CiviCRM',
    'operator' => 'OR',
    'separator' => 0,
  ]);
  _contactcats_civix_navigationMenu($menu);
}
