<?php
use CRM_Contactcats_ExtensionUtil as E;

return [
  [
    'name' => 'OptionValue_crm_search_display_contact_cat',
    'entity' => 'OptionValue',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'option_group_id.name' => 'search_display_type',
        'label' => E::ts('Category'),
        'value' => 'contact-cat',
        'name' => 'crm-search-display-contact-cat',
        'weight' => 6,
        'description' => E::ts('Shows the current and previous categories for this contact'),
        'icon' => 'fa-tag',
      ],
      'match' => [
        'option_group_id',
        'name',
      ],
    ],
  ],
  // Weird, so this bit belongs elsewhere
  [
    'name' => 'OptionValue_crm_search_display_contact_cat_SearchDisplay_Category_by_contact_Category_1',
    'entity' => 'SearchDisplay',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Category_by_contact_Category_1',
        'label' => E::ts('Category Category'),
        'saved_search_id.name' => 'Category_by_contact',
        'type' => 'contact-cat',
        'settings' => [
          'something' => 'nothing',
          'limit' => 50,
          'sort' => [],
          'pager' => [],
          // not sure about the columns bit.
          'columns' => [
            [
              'type' => 'field',
              'key' => 'id',
              'dataType' => 'Integer',
            ],
            [
              'type' => 'field',
              'key' => 'category_definition_id:label',
              'dataType' => 'Integer',
            ],
          ],
        ],
      ],
      'match' => [
        'name',
      ],
    ],
  ],
];
