<?php
use CRM_Contactcats_ExtensionUtil as E;

return [
  [
    'name' => 'CustomGroup_Category_changes',
    'entity' => 'CustomGroup',
    'cleanup' => 'unused',
    'update' => 'always',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Category_changes',
        'title' => E::ts('Category changes'),
        'extends' => 'Activity',
        'extends_entity_column_value:name' => ['changed_contact_category'],
        'style' => 'Inline',
        'help_pre' => E::ts(''),
        'help_post' => E::ts(''),
        'collapse_adv_display' => TRUE,
        'is_public' => FALSE,
        'icon' => '',
      ],
      'match' => ['name'],
    ],
  ],
  [
    'name' => 'CustomGroup_Category_changes_CustomField_Previous_Category',
    'entity' => 'CustomField',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'custom_group_id.name' => 'Category_changes',
        'name' => 'previous_category_id',
        'label' => E::ts('Previous Category'),
        'data_type' => 'EntityReference',
        'html_type' => 'Autocomplete-Select',
        'is_searchable' => TRUE,
        'is_view' => TRUE,
        'text_length' => 255,
        'note_columns' => 60,
        'note_rows' => 4,
        'column_name' => 'previous_category_id',
        'fk_entity' => 'ContactCategoryDefinition',
      ],
      'match' => [
        'name',
        'custom_group_id',
      ],
    ],
  ],
  [
    'name' => 'CustomGroup_Category_changes_CustomField_New_Category',
    'entity' => 'CustomField',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'custom_group_id.name' => 'Category_changes',
        'name' => 'new_category_id',
        'label' => E::ts('New Category'),
        'data_type' => 'EntityReference',
        'html_type' => 'Autocomplete-Select',
        'is_searchable' => TRUE,
        'is_view' => TRUE,
        'text_length' => 255,
        'note_columns' => 60,
        'note_rows' => 4,
        'column_name' => 'new_category_id',
        'fk_entity' => 'ContactCategoryDefinition',
      ],
      'match' => [
        'name',
        'custom_group_id',
      ],
    ],
  ],
];
